#include <iostream>

using namespace std;

int main()
{
    int a, b, n = 0;
    bool stevasemrda = true;
    cin >> a >> b;
    char matrica [a][b];
    for(int i = 0; i < a; i++){
        for(int j = 0; j < b; j++){
            cin >> matrica[i][j];
        }
    }
    while(stevasemrda){
       for(int i = 0; i < a; i++){
            for(int j = 0; j < b; j++){
                if(matrica[i][j] == 'X'){
                    if(i + 1 < a && matrica[i + 1][j] == '.')
                        matrica[i + 1][j] = 'x';
                    if(i - 1 >= 0 && matrica[i - 1][j] == '.')
                        matrica[i - 1][j] = 'x';
                    if(j + 1 < b && matrica[i][j + 1] == '.')
                        matrica[i][j + 1] = 'x';
                    if(j - 1 >= 0 && matrica[i][j - 1] == '.')
                        matrica[i][j - 1] = 'x';
                }
                else if(matrica[i][j] == 's')
                    matrica[i][j] = 'S';
            }
        }
        stevasemrda = false;
        for(int i = 0; i < a; i++){
            for(int j = 0; j < b; j++){
                if(matrica[i][j] == 'S'){
                    if(i + 1 < a && matrica[i + 1][j] == '.'){
                        matrica[i + 1][j] = 's';
                        stevasemrda = true;
                    }
                    if(i - 1 >= 0 && matrica[i - 1][j] == '.'){
                        matrica[i - 1][j] = 's';
                        stevasemrda = true;
                    }
                    if(j + 1 < b && matrica[i][j + 1] == '.'){
                        matrica[i][j + 1] = 's';
                        stevasemrda = true;
                    }
                    if(j - 1 >= 0 && matrica[i][j - 1] == '.'){
                        matrica[i][j - 1] = 's';
                        stevasemrda = true;
                    }
                }
                else if(matrica[i][j] == 'x')
                    matrica[i][j] = 'X';
            }
        }
    }
    for(int i = 0; i < a; i++){
            for(int j = 0; j < b; j++){
                if(matrica[i][j] == 'S')
                    n++;
            }
    }
    cout << n;
    return 0;
}